// 存储回调的集合
JeeWebSDK.FUNCTION_MAP = new Map();
// 成功回调
JeeWebSDK.successCallback = function (funcId, result) {
    const func = JeeWebSDK.FUNCTION_MAP.get(funcId);
    JeeWebSDK.FUNCTION_MAP.delete(funcId);
    if (func != null) {
        const res = JSON.parse(result);
        func.success(res);
        if (func.complete != null) {
            func.complete(res);
        };
    }
}
// 失败回调
JeeWebSDK.failCallback = function (funcId, result) {
    const func = JeeWebSDK.FUNCTION_MAP.get(funcId);
    JeeWebSDK.FUNCTION_MAP.delete(funcId);
    if (func != null) {
        const res = JSON.parse(result);
        func.fail(res);
        if (func.complete != null) {
            func.complete(res);
        };
    }
}
// 状态持续回调
JeeWebSDK.stateCallback = function (funcId, result) {
    const func = JeeWebSDK.FUNCTION_MAP.get(funcId);
    if (func != null) {
        const res = JSON.parse(result);
        func(res);
    }
}
// 结果持续回调
JeeWebSDK.resultCallback = function (funcId, result) {
    const func = JeeWebSDK.FUNCTION_MAP.get(funcId);
    if (func != null) {
        const res = JSON.parse(result);

        let typedArray = new Uint8Array(res.value.match(/[\da-f]{2}/gi).map(function (h) {
        return parseInt(h, 16)
        }))
        res.value = typedArray.buffer
        func(res);
    }
}

// 命令回调
JeeWebSDK.cmdCallback = function (funcId, result) {
    const func=JeeWebSDK.FUNCTION_MAP.get(funcId);
    JeeWebSDK.FUNCTION_MAP.delete(funcId);
    if (func != null) {
        func(JSON.parse(result));
    }
}

//进度
JeeWebSDK.progressCallback = function(key, progress) {
	const callback = JeeWebSDK.FUNCTION_MAP.get(key);
	const progressCallback = callback.progress;
	if (progressCallback !== null) {
		progressCallback(progress);
	}
};
// 成功回调
JeeWebSDK.successCallback = function(key, result, autoClear) {
	const callback = JeeWebSDK.FUNCTION_MAP.get(key);
	if (autoClear === true) {
		console.log("Android -----> auto clear");
		JeeWebSDK.FUNCTION_MAP.delete(key);
	}
	const success = callback.success;
	const complete = callback.complete;
	if (callback === null) {
		return;
	}
	let res = JSON.parse(result)
	if (success != null) {
//	    console.log("Android -----> handler success and complete");
		success(res);
		if (complete != null) {
			complete(res);
		}
	} else if (callback != null) {
		console.log("Android -----> "+res);
		callback(res);
	}
};
// 失败回调
JeeWebSDK.failCallback = function(key, result, autoClear) {
	const callback = JeeWebSDK.FUNCTION_MAP.get(key);
	if (autoClear === true) {
		console.log("Android -----> auto clear");
		JeeWebSDK.FUNCTION_MAP.delete(key);
	}
	const fail = callback.fail;
	const complete = callback.complete;
	if (callback === null) {
		return;
	}
	let res = JSON.parse(result)
	console.log("Android -----> parse result success");
	if (fail != null) {
		console.log("Android -----> handler fail callback");
		fail(res);
		if (complete != null) {
			complete(res);
		}
	} else if (callback != null) {
		console.log("Android -----> "+res);
		callback(res);
	}
};
// 接收命令回调
JeeWebSDK.onReceiveCallback = function (funId, result) {
    const fun = JeeWebSDK.FUNCTION_MAP.get(funId);
    if (fun != null) {
        const res = JSON.parse(result);
        fun(res);
    }
};
